// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:wyatt_ui_components/src/core/utils/multi_color.dart';
import 'package:wyatt_ui_components/src/domain/entities/buttons/button_style.dart';

class SimpleIconButtonStyle extends ButtonStyle {
  const SimpleIconButtonStyle({
    this.dimension = 30,
    super.radius = 5,
    super.padding = 5,
    super.foregroundColors,
    super.backgroundColors,
    super.borderColors,
    super.stroke = 2,
    super.shadow = const BoxShadow(
      blurRadius: 30,
      offset: Offset(0, 5),
      color: Color.fromRGBO(0, 0, 0, 0.05),
    ),
  });

  final double? dimension;

  @override
  SimpleIconButtonStyle copyWith({
    double? dimension,
    double? radius,
    double? padding,
    MultiColor? foregroundColors,
    MultiColor? backgroundColors,
    MultiColor? borderColors,
    double? stroke,
    BoxShadow? shadow,
  }) =>
      SimpleIconButtonStyle(
        dimension: dimension ?? this.dimension,
        radius: radius ?? radius,
        padding: padding ?? padding,
        foregroundColors: foregroundColors ?? foregroundColors,
        backgroundColors: backgroundColors ?? backgroundColors,
        borderColors: borderColors ?? borderColors,
        stroke: stroke ?? stroke,
        shadow: shadow ?? shadow,
      );
}
